/*
 The code is intended to be used with a V4.1 control board (without NRF24L01) and a single motor driver board.
 */

// This section describes the vehicle

#define SOP '<'
#define EOP '>'

bool started = false;
bool ended = false;

uint8_t buf[16]; // Array to store recieved data
uint8_t command[16]; // Array to store recieved data

byte index;

// Variables used in the program
byte Data_1 = 0x00; // Stores the first byte in the command string
byte Command_Val = 0x00; // Stores the command value
byte Data_Val = 0x00; // Stores the data value
byte Old_Data_Val = 0x00; // Stores the data value
byte servo_val = 0x00; // Stores the servo position value
int Door_Button;
int Door_Open = 0;
int Lock_Button;
int Lock_Open = 0;
int Data_Counter = 0;
int Load = 2;
int Pickup = 0;
int Old_Func_Val = 0;
int Func_Val = 0;

int _Left_Ind_Pin = A1;
int _Right_Ind_Pin = A3;
int _Tail_Lights_Pin = 5;
int _Motor_1_PWM_Pin = 6;
int _Motor_2_PWM_Pin = A0;
int _Motor_1_PWM_Value = 0;

unsigned long currentMillis = millis();

void setup() 
{
  Serial.begin(9600);

  pinMode(_Left_Ind_Pin, OUTPUT); // Right indicator
  pinMode(_Right_Ind_Pin, OUTPUT); // Left indicator
  pinMode(_Motor_1_PWM_Pin, OUTPUT); // Motor PWM
  pinMode(_Motor_2_PWM_Pin, OUTPUT); // Motor PWM

 }

void loop()
{
  check_serial();

if((millis()-currentMillis)>10000){
  analogWrite(_Motor_1_PWM_Pin,25);
  delay(200);
  analogWrite(_Motor_1_PWM_Pin,0);
  delay(200);
  analogWrite(_Motor_1_PWM_Pin,25);
  delay(200);
  analogWrite(_Motor_1_PWM_Pin,0);
  currentMillis = millis();
}

  if(command[0] == 0x01){

	if (command[7] < 120){ // These if functions leave a buffer zone of 15 bits above and below the drive center value
		_Motor_1_PWM_Value = map(command[7], 120, 0, 0,255);//drive_min, drive_max); // scale the data value for use with the motor
		analogWrite(_Motor_1_PWM_Pin,_Motor_1_PWM_Value); // Set the PWM vlue on pin 5 to move the motor
		digitalWrite(_Motor_2_PWM_Pin,LOW);
	}
	else if (command[7] > 135){
		_Motor_1_PWM_Value = map(command[7], 135, 255, 255,0);//drive_min, drive_max); // scale the data value for use with the motor
		analogWrite(_Motor_1_PWM_Pin,_Motor_1_PWM_Value); // Set the PWM vlue on pin 5 to move the motor
		digitalWrite(_Motor_2_PWM_Pin,HIGH);
	}
	else{
		analogWrite(_Motor_1_PWM_Pin,0);
		digitalWrite(_Motor_2_PWM_Pin,LOW);
	}
	
	if(((bitRead(command[9],4)) == 1)||((bitRead(command[9],3)) == 1)||((bitRead(command[9],2)) == 1)){
	if((120 < command[2]) && (command[2] < 135)){analogWrite(_Tail_Lights_Pin,255);}else{analogWrite(_Tail_Lights_Pin,125);}
	}
	else{analogWrite(_Tail_Lights_Pin,0);}
	  
  }
  else if(command[0] == 0x02){
	  if(command[1] == 0x01){
	  	digitalWrite(_Left_Ind_Pin, HIGH);
		digitalWrite(_Right_Ind_Pin, LOW);
	  }
	  else if(command[1] == 0x02){
	  	digitalWrite(_Left_Ind_Pin, LOW);
		digitalWrite(_Right_Ind_Pin, HIGH);
	  }
	  else if(command[1] == 0x03){
	  	digitalWrite(_Left_Ind_Pin, HIGH);
		digitalWrite(_Right_Ind_Pin, HIGH);
	  }
	  else if(command[1] == 0x00){
	  	digitalWrite(_Left_Ind_Pin, LOW);
		digitalWrite(_Right_Ind_Pin, LOW);
	  }
  }
}

void check_serial(){  
	  if (Serial.available()) { // Check if serial data is available

currentMillis = millis();
// Read all serial data available, as fast as possible
while(Serial.available() > 0)
{
char inChar = Serial.read();
if(inChar == SOP)
{
  index = 0;
  buf[index] = '\0';
  started = true;
  ended = false;
}
else if(inChar == EOP)
{
	if(index == 11){
		for (int i = 0; i < 12; i++) {
		command[i]=buf[i];
		}
	}
	else if(index == 2){
		 	   	  	 		for (int i = 0; i < 3; i++) {
		 	   	  	 		command[i]=buf[i];
		 	   	  	 		}
		 	}
  ended = true;
  break;
}
else
{
 if(index < 15)
 {
   buf[index] = inChar;
   index++;
   buf[index] = '\0';
 }
}
}

// We are here either because all pending serial
// data has been read OR because an end of
// packet marker arrived. Which is it?
if(started && ended)
{
// The end of packet marker arrived. Process the packet

// Reset for the next packet
started = false;
ended = false;
index = 0;
buf[index] = '\0';
}
	  }
}