/*

*/

// This section describes the vehicle

// Variables used in the program
byte ID = 1; // Vehicle ID Number
int Active = 1; // Variable to determine if the tractor is in active
int Last_Data_Timer = 0;
int Controller_Locked = 0;
int Receive_Count = 0;

int Controller_ID = 0;

uint8_t buf[16]; // Array to store recieved data

#include <SPI.h>
#include "RCTractorGuyRF24.h"
#include "RCTractorGuynRF24L01.h"
#include "RCTractorGuy.h"
#include <avr/wdt.h>

// Set up nRF24L01 radio on SPI bus plus pins 9 & 10
RF24 radio(9, 10);

// Initialise Vehicle
RCTractor TC118SS;

// Controller Address
const uint64_t Controller[5] = { 0xE8E8F0F0E1LL, 0xE8E8F0F0E2LL, 0xE8E8F0F0E3LL, 0xE8E8F0F0E4LL, 0xE8E8F0F0E5LL};
const uint64_t Controller_Listen[5] = { 0x3A3A3A3AD1LL, 0x3A3A3A3AD2LL, 0x3A3A3A3AD3LL, 0x3A3A3A3AD4LL, 0x3A3A3A3AD5LL };

void setup(void)
{
  // Start the NRF24L01
  radio.begin();

   /*(Steering, Rear_Link, Front_Link, Left_Ind, Right_Ind, Head_Lights, Tail_Lights, Work_Lights,
  Accessory_Lights, Left_Beacon, Right_Beacon, Reverse_Light)*/
  TC118SS.Define_Pins(0,0,0,0,0,0,0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0);
  
  // Initialise the library
  TC118SS.begin();

  pinMode(2, OUTPUT);
  pinMode(3, OUTPUT);

  radio.openReadingPipe(1, Controller[0]); // Set Address of Controller 1
  radio.openReadingPipe(2, Controller[1]); // Set Address of Controller 2
  radio.openReadingPipe(3, Controller[2]); // Set Address of Controller 1
  radio.openReadingPipe(4, Controller[3]); // Set Address of Controller 2
  radio.openReadingPipe(5, Controller[4]); // Set Address of Controller 2

  radio.startListening();

    Serial.begin(9600);
    wdt_enable(WDTO_250MS);    
}

void loop(void)
{

    buf[0] = 0;

    if ( radio.available() )
    {
        // Fetch the payload.
       radio.read( buf, sizeof(buf));

      // We recieved a string of ten bytes, four ID, one command and six data values but they may not be for this tractor
      if (buf[0] == ID) { // Confirm that the correct vehicle ID has been recieved


      int pipe_num = buf[11];

      long Vehicle_Voltage = TC118SS.ReadVcc();

     // First, stop listening so we can talk
      radio.stopListening();

      // Open the correct pipe for writing
      radio.openWritingPipe(Controller_Listen[pipe_num]);

      // Send battery voltage back.
      radio.write( &Vehicle_Voltage, sizeof(Vehicle_Voltage) );

      // Now, resume listening so we catch the next packets.
      radio.startListening();







        int Drive_Val = buf[2];
        int _Motor_PWM_Value = 0;
	
	if (Drive_Val < 120){ // These if functions leave a buffer zone of 15 bits above and below the drive center value
		_Motor_PWM_Value = map(Drive_Val, 120, 0, 0,255);//drive_min, drive_max); // scale the data value for use with the motor
		analogWrite(3,_Motor_PWM_Value);
		digitalWrite(2,LOW);
	}
	else if (Drive_Val > 135){
	_Motor_PWM_Value = map(Drive_Val, 135, 255, 255,0);//drive_min, drive_max); // scale the data value for use with the motor
		analogWrite(3,_Motor_PWM_Value);
		digitalWrite(2,HIGH);
	}
	else{
		analogWrite(3,0);
		digitalWrite(2,LOW);
	}	

	
	
	
	
	
	


        Last_Data_Timer = 10000;
        Active = 1;
      }
    }
    else if (Last_Data_Timer != 0) {
      Last_Data_Timer = Last_Data_Timer - 1;
    }
    else if (Last_Data_Timer == 0 && Active == 1) {
      Active = 0;
    }

    TC118SS.Timer();
    wdt_reset();

    /* if (Active == 1) {
      }
      else if (Controller_Locked != 0) {
       All_Controllers();
       Controller_Locked = 0;
      }*/

}